package handler

import (
	"fmt"
	"github.com/gorilla/websocket"
	"locking-kit-server/consts"
	"locking-kit-server/db"
	"log"
)

/**
 * @author yuanrh
 * @description websocket服务核心逻辑
 * @date 2021/6/28 11:11
 **/

var TaskSyncChanel = make(chan string, 10000)

//监听任务同步情况
func SubscriptionTaskSyncHandler(conn *websocket.Conn) (err error){

	//获取全部任务，包括 同步中、已同步、同步异常
	prefix := fmt.Sprintf("%v%v:%v",currentLoginUserId, consts.ETCD_DIRECTOR_TASK_SYNC, consts.TASK_SYNC_STATUS_WAIT)
	task,err := db.QueryWithPrefix(prefix)
	if err != nil{
		log.Printf("监听同步任务失败，%v", err)
		return err
	}

	for _, v := range task {
		if err := conn.WriteMessage(websocket.TextMessage, []byte(v)); err != nil {
			log.Printf("监听同步任务失败，%v", err)
			return err
		}
	}

	//任务同步信道
	for v := range TaskSyncChanel {
		if err := conn.WriteMessage(websocket.TextMessage, []byte(v)); err != nil {
			log.Printf("监听同步任务失败，%v", err)
			return err
		}
	}

	return nil
}


